#!/bin/bash

INFILE=$1
OUTFILE=$2
RES_FIT_FILE=$3
DCAFILE=$4

#SBATCH --time=0:15:00
#SBATCH -D /tmp

PROJECT_DIR=/lustre/nyx/hades/user/parfenov/mpd_summer2019/real-flow
TMPDIR=$PROJECT_DIR/TMPFLOW/TMP_${SLURM_JOB_ID}
mkdir -p $TMPDIR

OUTDIR=${OUTFILE%/*}
AFTERSLASHNAME=${INFILE##*/}
BASENAME=${AFTERSLASHNAME%.*}

LOG=${OUTDIR}/${BASENAME}_flow.OUT
ERR=${OUTDIR}/${BASENAME}_flow.ERR
#. /lustre/nyx/hades/user/parfenov/Soft/MPDRoot/build/config.sh
#source /cvmfs/hades.gsi.de/install/5.34.34/hydra2-4.9n/defall.sh

cp $PROJECT_DIR/utility.C $TMPDIR
cp $PROJECT_DIR/utility.h $TMPDIR
cp $PROJECT_DIR/MpdCalculator.C $TMPDIR
cp $PROJECT_DIR/MpdCalculator.h $TMPDIR
cp $PROJECT_DIR/main_flow.C $TMPDIR
cp $PROJECT_DIR/compile.sh $TMPDIR
cp $PROJECT_DIR/SpecFuncMathMore.h $TMPDIR
cp $PROJECT_DIR/example-resolutions.sh $TMPDIR

cd $TMPDIR
ls 1>$LOG 2>$ERR

. compile.sh 1>> $LOG 2>> $ERR

ls >> $LOG

root -l -b -q 'main_flow.C+("'${INFILE}'","'${OUTFILE}'","'$RES_FIT_FILE'","'${DCAFILE}'")'  1>> $LOG 2>> $ERR

cd $PROJECT_DIR
rm -rf $TMPDIR
